package fp;

import java.util.function.BiFunction;
import java.util.function.Function;

public class FunctionsUtil {
  public static <T, U, V> Function<U, V> partial(BiFunction<T, U, V> f, T x) {
    return u -> f.apply(x, u);
  }

  public static void main(String... args) {
    BiFunction<String, String, Boolean> f = String::startsWith;
    System.out.println(FunctionsUtil.partial(f, "abc").apply("a")); // true
  }
}
